
/**************************************************************************
 **                     C Code to read the SFMAIN.DAT
 **                     and convert it to a structure.
 **
 **                 By Kurt M. Warnstaff, 11/21/91, 1991
 **            if you have any questions, I can be reached at
 **
 **                B u f f a l o     C r e e k     B B S
 **                           (515) 225-8496
 *************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

enum bool {FALSE, TRUE};

#define   SPACE   0x20
#define   bool    enum bool
#define   byte    unsigned char

char * read_pas_string();
byte   read_pas_byte();
int    read_pas_int();
long   read_pas_long();
bool   read_pas_bool();


FILE * fp;        /* Global File Pointer */
char   stBuffer[60];

typedef struct {
	  int  usernum;
	  char username[30];
	  char passw[30];
	  char firstn[30];
	  int  baud;
	  byte  commport;
	  int  timeleft;
	  long time_entered;
	  char homepath[80];
	  bool ansi_on;
	  int  seclevel;
	  int  uploads, downloads;
	  int  thistime;
	  long timeon;
	  long extra_time;
	  bool sysnext, frontend, softcontrol;
	  long maxbaud;
	  bool errcorrect;
	  byte lastMconf, lastFarea, node;
	  int  downsperday, downstoday;
	  long bytesperday, bytestoday;
	  long totalUK, totalDK;
	} sf_rec;

char * read_pas_string()
{
  char tempBuf[60];
  char ch;
  int  i;

   while (ch=fgetc(fp), ch == SPACE || ch == '\n' ) {}
   for (i=0; ch != '\n'; i++) {
	tempBuf[i] = ch;
	ch = fgetc(fp);
   }
   tempBuf[i] = '\0';
   return tempBuf;
}

int read_pas_int()
{
   int tNum;

   fscanf (fp, "%dl", &tNum);
   return tNum;
}

byte read_pas_byte()
{
 char buf[20];

  byte tNum;
  fscanf(fp, "%d", &tNum);
  fgets(buf, 1, fp);
  return tNum;
}

bool read_pas_bool()
{
  char temp[20];

  strcpy (temp, read_pas_string());
  if (strcmp (temp, "FALSE") == 0)
      return FALSE;
  if (strcmp (temp, "TRUE") == 0)
      return TRUE;

}

long read_pas_long()
{
  long tNum;

  fscanf (fp, "%u", &tNum);
  return tNum;
}

void print_record (sf_rec * sf)
{
   clrscr();
  printf ("User Number: %d\n",sf->usernum);
  printf ("User Name  : %s\n",sf->username);
  printf ("Password   : %s\n",sf->passw);
  printf ("First Name : %s\n",sf->firstn);
  printf ("Baud Rate  : %d\n",sf->baud);
  printf ("Comm Port  : %d\n",sf->commport);
  printf ("Time Left  : %d\n",sf->timeleft);
  printf ("Time Entrd : %u\n",sf->time_entered);
  printf ("Home Path  : %s\n",sf->homepath);
  printf ("ANSI On?   : %s\n",(sf->ansi_on) ? "True" : "False");
  printf ("Security   : %d\n",sf->seclevel);
  printf ("Uploads    : %d\n",sf->uploads);
  printf ("Downloads  : %d\n",sf->downloads);
  printf ("This Time  : %d\n",sf->thistime);
  printf ("Time On    : %u\n",sf->timeon);
  printf ("Extra Time : %u\n",sf->extra_time);
  printf ("Sysop Next : %s\n",(sf->sysnext) ? "True" : "False");
  printf ("Frontend   : %s\n",(sf->frontend) ? "True" : "False");
  printf ("Softw Cntrl: %s\n",(sf->softcontrol) ? "True" : "False");
  printf ("Max Baud   : %u\n",sf->maxbaud);
  printf ("Err Correct: %s\n",(sf->errcorrect) ? "True" : "False");
  printf ("Last M Conf: %d\n",sf->lastMconf);
  printf ("\nHit any key for the rest\n");
  getch();
  clrscr();
  printf ("Last F Area: %d\n",sf->lastFarea);
  printf ("Node       : %d\n",sf->node);
  printf ("Downs p Day: %d\n",sf->downsperday);
  printf ("Downs Today: %d\n",sf->downstoday);
  printf ("Bytes p Day: %u\n",sf->bytesperday);
  printf ("Bytes Today: %u\n",sf->bytestoday);
  printf ("Total UK   : %u\n",sf->totalUK);
  printf ("Total DK   : %u\n",sf->totalDK);
}


void main ()
{
  /* first allocate space for the struct */
  sf_rec * sf;

  if ( (sf = (sf_rec *)calloc(1, sizeof(sf_rec))) == NULL ) {
       putch (0x07);
       printf ("Sorry can't allocate the memory for the structure");
       exit (0);
  }
       /* All fine, now we can start reading in the file */

  if ((fp = fopen ("SFMAIN.DAT","r")) == NULL) {
	putch (0x07);
	printf ("File not found... Aborting!!!");
	exit (0);
  }
  sf->usernum      = read_pas_int();
  strcpy (sf->username, read_pas_string());
  strcpy (sf->passw, read_pas_string());
  strcpy (sf->firstn, read_pas_string());
  sf->baud         = read_pas_int();
  sf->commport     = read_pas_byte();
  sf->timeleft     = read_pas_int();
  sf->time_entered = read_pas_long();
  strcpy (sf->homepath, read_pas_string());
  sf->ansi_on      = read_pas_bool();
  sf->seclevel     = read_pas_int();
  sf->uploads      = read_pas_int();
  sf->downloads    = read_pas_int();
  sf->thistime     = read_pas_int();
  sf->timeon       = read_pas_long();
  sf->extra_time   = read_pas_long();
  sf->sysnext      = read_pas_bool();
  sf->frontend     = read_pas_bool();
  sf->softcontrol  = read_pas_bool();
  sf->maxbaud      = read_pas_long();
  sf->errcorrect   = read_pas_bool();
  sf->lastMconf    = read_pas_byte();
  sf->lastFarea    = read_pas_byte();
  sf->node         = read_pas_byte();
  sf->downsperday  = read_pas_int();
  sf->downstoday   = read_pas_int();
  sf->bytesperday  = read_pas_long();
  sf->bytestoday   = read_pas_long();
  sf->totalUK      = read_pas_long();
  sf->totalDK      = read_pas_long();
  print_record (sf);
  getch();

  fclose (fp);
}
